var router = require('express').Router();

/* GET users listing. */
router.get('/', function(req, res) {
  var userDb = req.app.get('userDb');

  userDb.readAll (function (data) {
    res.send(data);
  });
});

router.post('/', function(req, res) {
  var userDb = req.app.get('userDb');

  userDb.create(req.body, function (data) {
    res.send(data);
  });
});

router.get('/:userId', function(req, res) {
  var userDb = req.app.get('userDb');

  userDb.read (req.params.userId, function (user_data) {
    activitiesDb = req.app.get('activitiesDb');

    activitiesDb.readAll (req.params.userId, function (activ_data) {
      user_data.activities = [];
      for (var i=0,  tot=activ_data.length; i < tot; i++) {
        user_data.activities.push(activ_data[i]);
      }

      res.send(user_data);
    });
  });
});

router.put('/:userId', function(req, res) {
  var userDb = req.app.get('userDb');

  userDb.update (req.params.userId, req.body, function (data) {
    res.send(data);
  });
});

router.delete('/:userId', function(req, res) {
  var userDb = req.app.get('userDb');

  userDb.delete (req.params.userId, function (data) {
    res.send(data);
  });
});

module.exports = router;
