/**
 * Created by tomwalsh on 18/04/2014.
 */
var S = require('sequelize');

var activities = function (){};
var activitiesDAO = {};

var _activitiesDAO = {
  id: {type: S.INTEGER, unique: true, primaryKey: true, autoIncrement: true},
  userId: S.INTEGER,
  kind: S.STRING,
  location: S.STRING,
  distance: S.FLOAT
};


module.exports = function () {
  return new activities ();
};

function _cleanData (data)
{
  if (!data || !data.dataValues)
    return null;

  return data.dataValues;
}

activities.prototype.init = function init (sequelize) {
  activitiesDAO = sequelize.define('activities', _activitiesDAO, {tableName: 'activities', timestamps: false});
};

activities.prototype.readAll = function readAll (usrId, result) {
  activitiesDAO.findAll ({where: {userId: usrId}}).success (function (dataOut) {
    var ret = [];
    for (var i = 0, len = dataOut.length; i < len; i++) {
      ret.push (dataOut[i].dataValues);
    }
    result (ret);
  });
};

activities.prototype.create = function create (usrId, dataIn, result) {
  dataIn.userId = usrId;
  activitiesDAO.build (dataIn).save ().success (function (dataOut) {
    result (_cleanData (dataOut));
  });
};

activities.prototype.read = function read (usrId, activityId, result) {
  activitiesDAO.find ({where: {id: activityId, userId: usrId}}).success (function (dataOut) {
    result (_cleanData (dataOut));
  });
};

activities.prototype.update = function update (usrId, activityId, dataIn, result) {
  activitiesDAO.update (dataIn, {id: activityId, userId: usrId}).success (function (dataOut) {
    result (_cleanData (dataOut));
  });
};

activities.prototype.delete = function del (usrId, activityId, result) {
  activitiesDAO.destroy ({id: activityId, userId: usrId}).success (function (dataOut) {
    result (_cleanData (dataOut));
  });
};