/**
 * Created by tomwalsh on 18/04/2014.
 */
var S = require('sequelize');

var users = function (){};
var userDAO = {};

var _userDAO = {
  id: {type: S.INTEGER, unique: true, primaryKey: true, autoIncrement: true},
  email: {type: S.STRING, unique: true},
  firstName: S.STRING,
  lastName: S.STRING,
  password: S.STRING
};

module.exports = function (){
  return new users ();
};

function _cleanData (data)
{
  if (!data || !data.dataValues)
    return null;

  return data.dataValues;
}

users.prototype.init = function init (sequelize) {
  userDAO = sequelize.define ('users', _userDAO, {tableName: 'users', timestamps: false});
};

users.prototype.loadData = function loadData (data) {
  data.forEach (function (datum) {
    userDAO.findOrCreate(datum, datum).success (function (dataOut, created) {
      if (created)
        console.log (dataOut.dataValues);
    });
  });
}

users.prototype.readAll = function readAll (result) {
  userDAO.findAll ().success (function (dataOut) {
    var ret = [];
    for (var i = 0, len = dataOut.length; i < len; i++) {
      ret.push (dataOut[i].dataValues);
    }

    result (ret);
  });
};

users.prototype.read = function read (userId, result) {
  userDAO.find ({where: {id: userId}}).success (function (dataOut) {
    result (_cleanData (dataOut));
  });
};

users.prototype.create = function create (dataIn, result) {
  userDAO.build (user_data).save ().success (function (dataOut) {
    result (_cleanData (dataOut));
  });
};

users.prototype.update = function update (userId, dataIn, result) {
  userDAO.update (dataIn, {id: userId}).success (function (dataOut) {
    result (_cleanData (dataOut));
  });
};

users.prototype.delete = function del (userId, result) {
  userDAO.destroy ({id: userId}).success (function (dataOut) {
    result (_cleanData (dataOut));
  });
};